<template>
    <div class="editor notebook slideover" :class="{'open': open}">
        <notebook-placeholder :notebook="currentNotebook"></notebook-placeholder>
        <note-tags @choosenTags="updateTags"></note-tags>
        <note-list :small="true" :notes="notes" @selected="goToSelectedNote"></note-list>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { INotebook } from '@/store/types/notebooks'
import { INote } from '@/store/types/notebooks'
import NotebookPlaceholder from '@/app/Editor/components/primitives/NotebookPlaceholder.vue'
import NoteList from '@/app/Editor/components/Note/primitives/NoteList.vue'
import NoteTags from '@/app/Editor/components/Note/primitives/NoteTags.vue'
import { ITag } from '@/store/types/tags'

@Component({
    components: { NotebookPlaceholder, NoteList, NoteTags },
})
export default class OtherNotesInNotebook extends Vue {
    // Props

    @Prop() currentNotebook: INotebook | undefined
    @Prop() open: boolean | undefined

    // Data

    tags: ITag[] = []

    // Computed

    get notes(): INote[] {
        if (!this.currentNotebook || !this.currentNotebook.notes) return []
        if (this.tags.length < 1) return this.currentNotebook.notes
        const notes = this.currentNotebook.notes.filter(note => {
            const tags = note.tags.filter(tagInNote => {
                const found = this.tags
                    .map(tagInFilter => tagInFilter.id)
                    .filter(filterID => filterID === tagInNote.id)
                return found.length > 0
            })
            if (tags.length == this.tags.length) return true
            return false
        })
        return notes
    }

    // Methods

    goToSelectedNote(note: INote) {
        if (note.id) {
            const url = `/notebook/${note.notebook.id}/${note.id}/`
            if (this.$route.fullPath !== url) this.$router.push(url)
        }
    }

    updateTags(tags: ITag[]) {
        this.tags = tags
    }
}
</script>